import { WebGPUObjectError } from '../utils/errors.js'

export class BindGroupLayout {
  _device: GPUDevice
  _handle: GPUBindGroupLayout

  get handle() {
    return this._handle
  }

  get label() {
    return this._handle.label
  }

  constructor(device: GPUDevice, layout: GPUBindGroupLayout) {
    this._device = device
    this._handle = layout
  }

  static create(device: GPUDevice, descriptor: GPUBindGroupLayoutDescriptor) {
    try {
      return new BindGroupLayout(
        device,
        device.createBindGroupLayout(descriptor)
      )
    } catch (err) {
      throw WebGPUObjectError.from(err, BindGroupLayout)
    }
  }
}

